package com.foreverwin.mesnac.equip.controller;

import com.foreverwin.modular.core.util.R;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.CommonMethods;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.foreverwin.mesnac.equip.service.InspectPlanUserGroupService;
import com.foreverwin.mesnac.equip.model.InspectPlanUserGroup;
import java.util.List;

/**
 *
 * @author pavel.Liu
 * @since 2021-06-18
 */
@RestController
@RequestMapping("/Z-INSPECT-PLAN-USER-GROUP")
public class InspectPlanUserGroupController {

    @Autowired
    public InspectPlanUserGroupService inspectPlanUserGroupService;

    /**
    * 根据id查询
    *
    * @param id 主键
    * @return
    */
    @ResponseBody
    @GetMapping("/{id:.+}")
    public R getInspectPlanUserGroupById(@PathVariable String id) {
        return R.ok( inspectPlanUserGroupService.getById(id));
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @GetMapping("")
    public R getInspectPlanUserGroupList(InspectPlanUserGroup inspectPlanUserGroup){
        List<InspectPlanUserGroup> result;
        QueryWrapper<InspectPlanUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(inspectPlanUserGroup);
        result = inspectPlanUserGroupService.list(queryWrapper);
        return R.ok(result);
    }

    /**
     * 分页查询数据
     *
     * @param frontPage  分页信息
     * @return
     */
    @ResponseBody
    @GetMapping("/page")
    public R page(FrontPage<InspectPlanUserGroup> frontPage, InspectPlanUserGroup inspectPlanUserGroup){
        IPage result;
        QueryWrapper<InspectPlanUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(inspectPlanUserGroup);
        if (frontPage.getGlobalQuery() != null && !"".equals(frontPage.getGlobalQuery().trim())) {
            //TODO modify global query
            queryWrapper.lambda().and(wrapper -> wrapper
                .like(InspectPlanUserGroup::getHandle, frontPage.getGlobalQuery())
                .or().like(InspectPlanUserGroup::getUserGroupBo, frontPage.getGlobalQuery())
                .or().like(InspectPlanUserGroup::getResourceInspectPlanBo, frontPage.getGlobalQuery())
                .or().like(InspectPlanUserGroup::getCreateUser, frontPage.getGlobalQuery())
                .or().like(InspectPlanUserGroup::getModifyUser, frontPage.getGlobalQuery())
    );
        }
        result = inspectPlanUserGroupService.page(frontPage.getPagePlus(), queryWrapper);
        return R.ok(result);
    }

    /**
     * 新增
     * @param inspectPlanUserGroup  传递的实体
     * @return  null 失败  实体成功
     */
    @PostMapping
    public R save(@RequestBody InspectPlanUserGroup inspectPlanUserGroup) {
        return R.ok(inspectPlanUserGroupService.save(inspectPlanUserGroup));
    }

    /**
     * 修改
     * @param inspectPlanUserGroup  传递的实体
     * @return  null 失败  实体成功
     */
    @PutMapping
    public R updateById(@RequestBody InspectPlanUserGroup inspectPlanUserGroup) {
        return R.ok(inspectPlanUserGroupService.updateById(inspectPlanUserGroup));
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     * @return 0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.DELETE, value = "/{id:.+}")
    public R removeById(@PathVariable("id") String id){
        return R.ok(inspectPlanUserGroupService.removeById(id));
    }

    /**
     * 批量删除对象
     * @param ids 实体集合ID
     * @return  0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.POST, value = "/delete-batch")
    public R removeByIds(List<String> ids){
        return R.ok(inspectPlanUserGroupService.removeByIds(ids));
    }
}